'======================================================================
' STEGA V.4alpha					1990 (c) Rckle
'======================================================================
' Programm zum Plotten der Konzentrationsverlufe, die mit dem Programm
' STOER V1.00 - v2.00 zur VDI Richtlinie 3782 Blatt 1 berechnet wurden.
'
' Folgende gerechnete Szenarien lassen sich derzeit darstellen:
' 1. Der Standard-Fall -
'    4 Flle: vorgeg. Ausbreitungssituation und 3 vesch. Schichtungen
'    bei 1 m/s.
' 2. Mehrere Rechnungen hintereinander, z.B. versch. Aufpunkte oder
'    Variationen anderer Parameter.
' 3. Einzelne explizit vorgegebene Ausbreitungssituationen, z.B.
'    labile Schichtung ohne Inversion bei vorgegebenen zeitlichen
'    Sttzstellen.
'
' Noch nicht behandelbar sind Flle, bei denen eine berhhung zu 
' bercksichtigen ist.
'----------------------------------------------------------------------
' Aufruf: STEGA [lw:]datei[/BW]
'	  lw:	- Laufwerk und Pfadname
'	  datei - gltiger Dateiname
'	  /BW	- Option schwarz-wei-Ausgabe der Kurven (fr Hardcopy)
' Restriktionen:
' o EGA oder VGA Karte mu vorhanden sein und mittels der SCREEN-
'   Befehle von BASIC aus ansteuerbar sein.
' o Die Eingabedatei mu mit dem Programm STOER erstellt worden sein.
'----------------------------------------------------------------------
' Programmentwicklung:
' V.1  07.09.88  fr den Hausgebrauch
' V.2  29.12.88  Hardcopy-Programm kann nicht alle Farben erkennen =>
'                zustzliche Option - schwarz/wei-Darstellung
' V.3  04.08.89  Umstellung auf Ausgabedatei des Programms STOER V1.00
' V.4  19.04.90  einige Verbesserungen, u.a. mehrere Aufpunkte knnen
'		 behandelt werden
'======================================================================
	OPTION BASE 1
' LL ist die maximale Zahl der Kurven
	LL=4
' NN ist die maximale Zahl der Kurvensttzstellen
	NN=100
' Dimensionierung T-Zeit und C-Konzentration
	DIM T(NN,LL),C(NN,LL)
' Schichtung, Transportgeschwindigkeit und Inversionshhe
	DIM ISCH(4),UT$(4),INV$(4)
' Art der Schichtung
	DIM SCH$(3)
        DATA "stabil     ","indifferent","labil      "
        FOR I=1 TO 3 : READ SCH$(I) : NEXT

' die LSTYL-Werte bestimmen die Art der Kurve (durchgezogen, punktiert,
' gestrichelt oder strichpunktiert)
' hat eine Kurve viele Sttzstellen (mehr als ca. 40, sollten hier zwecks
' besserer Unterscheidung der Kurven im schwarz-wei-Mode andere Werte
' gewhlt werden.
	DIM LSTYL(4)
	DATA &HFFFF,&HCCCC,&HF0F0,&HF10F
	FOR L=1 TO 4 : READ LSTYL(L) : NEXT

'----------------------------------------------------------------------
' Eingabedateinamen aus der Kommandozeile oder von der Tastatur lesen
	FILE$=COMMAND$
	IF (LEN(FILE$)=0) THEN INPUT "Datei";FILE$
' Schwarz-Wei Option
	I=INSTR(FILE$,"/")
	IF I>0 THEN
	 B$=MID$(FILE$,I+1,1)
	 IBW=INSTR("bB",MID$(FILE$,I+1,1))
	 FILE$=LEFT$(FILE$,I-1)
	END IF
' Datei ffnen	
	OPEN "I",#1,FILE$

'----------------------------------------------------------------------
' jetzt kanns losgehen
'----------------------------------------------------------------------
START:
' bis zur Kennung STOER lesen
	WHILE NOT EOF(1)
	LINE INPUT #1,A$
	?A$
	IF INSTR(A$,"STOER V")>0  THEN GOTO FIND1
	WEND
	CLOSE
	IF N=0 THEN PRINT "- falsche Eingabedatei -'
	END

FIND1:
' Bildschrim lschen
	CLS
	LINE INPUT #1,A$
' Titel einlesen
	LINE INPUT #1,TITEL$
	PRINT CHR$(201);
	GOSUB DOUBL
	PRINT CHR$(187)
	A$=TITEL$
	GOSUB BLINE
	PRINT CHR$(204);
	GOSUB DOUBL
	PRINT CHR$(185)

' Kurvenzhler L initialisieren
	L=0
' zunchst Input nicht darstellen
	SHOW=-1
'---------------------------------------------------------------------
' Die Ergebnisdatei einlesen und analysieren
ZEILE:
' wenn max. Anzahl von Kurven (4) erreicht, dann darstellen
	IF (L=LL) THEN GOTO WARTE
	IF (INSTR(A$,"STOER V")>0) THEN
	 ENTRY=1
	 GOTO WARTE
	 END IF
' Ende der Datei erreicht ?
	IF EOF(1) THEN
	 CLOSE
	 IF (L>0) THEN
	  ENTRY=-1
	  GOTO WARTE
	  ELSE
	  PRINT "- unexpected EOF -"
	  END
	  END IF
       	 END IF
' Zeile lesen und wenn SHOW=.TRUE. darstellen
	LINE INPUT #1,A$
	IF (SHOW AND (LEN(A$)>0) AND MID$(A$,2,1)<>"*") THEN GOSUB BLINE

' wenn Kennung "oord" (Koordinaten), dann Aufpunktdaten extrahieren
	IF (INSTR(A$,"oord")<>0)  THEN
' Display der folgenden Zeilen abstellen
	 SHOW=0
	 AUFP$=MID$(A$,INSTR(A$,"XA"))

	 PRINT CHR$(199);
	 GOSUB SINGL
	 PRINT CHR$(182)
	 A$=" Kurve    Schichtung    Transportgeschw.   Inversion    (n)"
	 GOSUB BLINE
	 PRINT CHR$(199);
	 GOSUB SINGL
	 PRINT CHR$(182)
	 END IF
' Feststellen welche Schichtung
	IF (INSTR(A$,"Schi")>0) THEN
	 ISCH(L+1)=VAL(MID$(A$,22,3))
	 END IF
' und welche Transportgeschwindigkeit
	IF (INSTR(A$,"Trans")>0) THEN
	 UT$(L+1)=RIGHT$(A$,9)
	 END IF
' Inversionsverhltnisse
	IF (INSTR(A$,"Inver")>0) THEN
	 IF (INSTR(A$,"mit")>0)	  THEN
          INV$(L+1)=RIGHT$(A$,9)
	  ELSE
	  INV$(L+1)="    ---  "
	  END IF
	 END IF

' weiter Lesen bis zur Kennung "(mg/m**3)"
	IF (INSTR(A$,"(mg/m**3)")=0)	  THEN GOTO ZEILE
'--------------------------------------------------------------------
' ab hier kommen Konzentrationsverlufe (in der Regel 4 Stck)
	L=L+1
' welche Kurven werden gezeichnet
	PRINT CHR$(186)"  "L"      "SCH$(ISCH(L)),UT$(L),"  "INV$(L)TAB(79)CHR$(186)
'	IF (L>LL)	GOTO WARTE
' Zhler der Datenpaare (Zeit / Konzentration)
	N=0
DATEN:
	N=N+1
	LINE INPUT #1,A$
	IF (LEN(A$)<1) THEN GOTO ZEILE
	TT=VAL(LEFT$(A$,15))
	CC=VAL(RIGHT$(A$,15))
'	INPUT#1,TT,CC
'	PRINT L,N,TT,CC
' ist TT=0 und CC=0, dann Ende des Konzentrationsverlaufs erreicht,
' d.h. erst mal weitere Zeilen berlesen, bis nchster Konz.verlauf
' folgt.
'	IF (TT=0 AND CC=0) GOTO ZEILE
' in T und C werden die Konzentrationsverlufe abgespeichert
	T(N,L)=TT
	C(N,L)=CC
	IF (NOT EOF(1)) GOTO DATEN

'----------------------------------------------------------------------
' jetzt sind 4 Kurven aus Ergebnisdatei eingelesen
' Ausgabe des Diagramms auf Tastendruck
'----------------------------------------------------------------------
WARTE:
	PRINT CHR$(200);
	GOSUB DOUBL
	PRINT CHR$(188)

	GOSUB KEYPR
' Min und Max bestimmen
	N=N-1
	CMIN=1E6
	CMAX=0.
	FOR L=1 TO LL
	 FOR I=1 TO N
	  IF C(I,L)<CMIN THEN
	   CMIN=C(I,L)
	  ELSE
	   IF C(I,L)>CMAX THEN CMAX=C(I,L)
	  END IF
	 NEXT
	NEXT
' keine Immission ? (evtl. ungnstiger Aufpunkt)
	IF (CMAX=0) THEN
	 PRINT "- keine Immissionen vorhanden -"
	 GOTO START
	 END IF
' 10er-Potenz und Faktor fr Multiplikation
	POT=INT(LOG(CMAX)/LOG(10))
	FAK=10^-POT
	FOR L=1 TO LL
	 FOR I=1 TO N
	 C(I,L)=C(I,L)*FAK
	 NEXT
	NEXT
	CMAX=CMAX*FAK
	CMIN=CMIN*FAK
	ICMAX=INT(CMAX)+1
' Tmax bestimmen
	TMIN=0.
	TMAX=T(N,1)
	FOR L=2 TO LL
	 IF T(N,L)>TMAX THEN TMAX=T(N,L)
	NEXT
        		     ISTEP= 10
        IF (TMAX>120)	THEN ISTEP= 60
        IF (TMAX>600)	THEN ISTEP=300
        IF (TMAX>1500)	THEN ISTEP=600
        ITMAX=INT(TMAX/ISTEP)*ISTEP+ISTEP
'----------------------------------------------------------------------
' jetzt kommt die Grafik
'----------------------------------------------------------------------
	SCREEN 9
	DX=500/ITMAX
	DY=250/ICMAX
' Titelzeile
	PRINT " VDI 3783 Blatt 1  "+LEFT$(TITEL$,54);
	LOCATE 1,77
	PRINT "R.4";
	LINE (0,0)-(639,13),,B
	LINE (0,0)-(3,13),,B
	LINE (140,0)-(143,13),,B
	LINE (597,0)-(600,13),,B
' Aufpunktkoordinaten ber das Bild
	LOCATE 3,30
	PRINT AUFP$;

' Rahmen
	LINE (100,50)-(600,300),,B
	LOCATE 23,76
	PRINT "t"

	LOCATE 3,3
	PRINT "C"

	LOCATE 4,1
	IF (POT<>0) THEN PRINT USING "&+#";"* 1E";POT
'	IF (POT<>0) THEN PRINT USING "*#.#^^^^";1/FAK
	PRINT "mg/m^3"

' y-Achsenbeschriftung
	FOR I=1 TO ICMAX
	 Y=300-I*DY
	 LINE (595,Y)-(600,Y)
	 LINE (100,Y)-(105,Y)
	 LOCATE CINT((Y+5)/14),10
	 IF (ICMAX<6 OR (I MOD 2=0)) THEN PRINT I;
	NEXT
	FOR I=0.5 TO ICMAX STEP 0.5
	 Y=300-I*DY
	 LINE (598,Y)-(600,Y)
	 LINE (100,Y)-(102,Y)
	NEXT

' x-Achsenbeschriftung
	FOR I=ISTEP TO TMAX STEP ISTEP
	 X=100+I*DX
	 LINE (X,50)-(X,54)
	 LINE (X,300)-(X,304)
	 LOCATE 23,CINT(X/8)-2
	 PRINT I;
	NEXT
	FOR I=ISTEP/2 TO ITMAX STEP ISTEP/2
	 X=100+I*DX
	 LINE (X,50)-(X,52)
	 LINE (X,300)-(X,302)
	NEXT

' Legende
	LOCATE 25,15
	PRINT "m.Wetterl.";
	LOCATE 25,33
	PRINT "stabil";
	LOCATE 25,48
	PRINT "indifferent";
	LOCATE 25,67
	PRINT "labil";

' Konzentrationsverlufe zeichnen
	IF IBW>0 THEN
' Schwarz-wei
	 FOR L=1 TO LL
	  X=100+T(1,L)*DX
	  Y=300-C(1,L)*DY

	  FOR I=2 TO N
	   XT=100+T(I,L)*DX
	   YT=300-C(I,L)*DY
	   LINE (X,Y)-(XT,YT),15,,LSTYL(L)
	   LINE (X,Y+1)-(XT,YT+1),15,,LSTYL(L)
	   X=XT
	   Y=YT
	  NEXT
	 NEXT
	 FOR L=1 TO 4
	  XL=135*(L-1)
	  LINE (100+XL,332)-(200+XL,349),15,B,LSTYL(L)
	 NEXT
	ELSE
' In Farbe
	 FOR L=1 TO LL
	  X=100+T(1,L)*DX
	  Y=300-C(1,L)*DY

	  FOR I=2 TO N
	   XT=100+T(I,L)*DX
	   YT=300-C(I,L)*DY
	   LINE (X,Y)-(XT,YT),L+10
	   LINE (X,Y+1)-(XT,YT+1),L+10
	   X=XT
	   Y=YT
	  NEXT
	 NEXT
	 FOR L=1 TO 4
	  XL=135*(L-1)
	  LINE (100+XL,332)-(200+XL,349),L+10,B
	 NEXT
	END IF
'----------------------------------------------------------------------
ENDE:
	GOSUB KEYPR
	SCREEN 0
'----------------------------------------------------------------------
' hier gibt es verschiedene Mglichkeiten weiterzumachen
' 1.) Standard-Fall ist bereits behandelt - Ende
' 2.) mehrere Aufpunkte oder Flle hintereinander in der Ergebnisdatei
'     - nacheinander darstellen
' 3.) Fall mit berhhung, d.h. weitere Konzentrationsverlufe bei den
'     3 Schichtungen mit zunehmender Geschwindigkeit vorhanden -
'     ? noch nicht behandelt

	IF ENTRY=-1 THEN END
	IF ENTRY=1 THEN
	 ENTRY=0
	 GOTO FIND1
         ELSE
	 GOTO START
         END IF

	END
'----------------------------------------------------------------------
' Unterprogramm KEYPR wartet auf Tastendruck
'----------------------------------------------------------------------
KEYPR:
	IF INKEY$="" GOTO KEYPR
	RETURN
	END
'----------------------------------------------------------------------
' Unterprogramm BLINE gibt eine Zeile mit linkem und rechtem Begrenzer
' aus
'----------------------------------------------------------------------
BLINE:
	PRINT CHR$(186)" ";A$TAB(79)CHR$(186)
	RETURN
	END
'----------------------------------------------------------------------
' Unterprogramm BLINE gibt Doppellinie aus
'----------------------------------------------------------------------
DOUBL:
	FOR I=1 TO 77 : PRINT CHR$(205); : NEXT
	RETURN
	END
'----------------------------------------------------------------------
' Unterprogramm SINGL gibt Einfachlinie aus
'----------------------------------------------------------------------
SINGL:
	FOR I=1 TO 77 : PRINT CHR$(196); : NEXT
	RETURN
	END
